import { z } from 'zod';
import type { APIContext } from '../../../@types/astro.js';
import type { MaybePromise } from '../utils.js';
import { type ErrorInferenceObject, type SafeResult } from './shared.js';
export * from './shared.js';
export { z } from 'zod';
export declare function defineAction<TOutput, TAccept extends 'json' | 'form' | undefined, TInputSchema extends z.ZodType>({ accept, input: inputSchema, handler, }: {
    input?: TInputSchema;
    accept?: TAccept;
    handler: (input: z.infer<TInputSchema>, context: APIContext) => MaybePromise<TOutput>;
}): ((input: TAccept extends 'form' ? FormData : z.input<TInputSchema>) => Promise<Awaited<TOutput>>) & {
    safe: (input: TAccept extends 'form' ? FormData : z.input<TInputSchema>) => Promise<SafeResult<z.infer<TInputSchema> extends ErrorInferenceObject ? z.infer<TInputSchema> : ErrorInferenceObject, Awaited<TOutput>>>;
};
